//==============================================
//      File dictreg.pas
//
//      Components library for Delphi and BCB++.
//      DesignTime   TDictionaryMgr.
//      DesignTime for TDictionaryMgr component.
//
//      Copyright 1998-2001 Polaris Software
//      http://polesoft.da.ru
//      mailto: PolarisLib@mail.ru
//==============================================
unit DictReg;

{$I POLARIS.INC}

interface

uses Classes, SysUtils, Controls, TypInfo, Consts, ComCtrls,
     DB, DBTables,
     {$IFDEF POLARIS_D6}DesignIntf,DesignEditors,{$ELSE}DsgnIntf,{$ENDIF}
     DVEditor,  DictItem;

procedure Register;

implementation

procedure Register;
begin
  RegisterComponents('Polaris DB',[TDictionaryMgr]);
{$IFDEF POLARIS_D3}
  RegisterNonActiveX([TDictionaryMgr], axrComponentOnly);
{$ENDIF}
  RegisterNoIcon([TDictionaryItem]);
//  RegisterClasses([TDictionaryItem]);
  {DictionaryMgr}
  RegisterComponentEditor(TDictionaryMgr, TDictionaryMgrEditor);
  RegisterPropertyEditor(TypeInfo(TList), TDictionaryMgr, 'NodeProxies',
                         TNodeListProperty);
  RegisterPropertyEditor(TypeInfo(TTreeView), TDictionaryMgr, 'MgrOwner',
                         TMgrOwnerProperty);
  RegisterPropertyEditor(TypeInfo(TDictionaryItem), TDictionaryMgr, 'ActiveItem',
                         TActiveItemProperty);
  {DictionaryItem}
  RegisterPropertyEditor(TypeInfo(String), TDictionaryItem, 'NodeName',
                         TRootNodeProperty);
  RegisterPropertyEditor(TypeInfo(TDBDataSet), TDictionaryItem, 'DataSet',
                         TDictDataSetProperty);
  RegisterPropertyEditor(TypeInfo(String), TDictionaryItem, 'ParentFieldName',
                         TDictFieldProperty);
  RegisterPropertyEditor(TypeInfo(String), TDictionaryItem, 'OwnerFieldName',
                         TDictFieldProperty);
  RegisterPropertyEditor(TypeInfo(String), TDictionaryItem, 'DisplayFieldName',
                         TDictFieldProperty);
  RegisterPropertyEditor(TypeInfo(String), TDictionaryItem, 'SourceFieldName',
                         TDictFieldProperty);
  RegisterPropertyEditor(TypeInfo(TDataSet), TDictionaryItem, 'RootDataSet',
                         TRootDataSetProperty);
  RegisterPropertyEditor(TypeInfo(TDataSet), TDictionaryItem, 'ConnectedDataSet',
                         TConnectedDataSetProperty);
  RegisterPropertyEditor(TypeInfo(String), TDictionaryItem, 'ConnectedFieldName',
                         TConnectedFieldProperty);
  RegisterPropertyEditor(TypeInfo(Integer), TDictionaryItem, 'MaxLevel',
                         TMaxLevelProperty);
  RegisterPropertyEditor(TypeInfo(TDictionaryMgr), TDictionaryItem, 'ItemOwner',
                         TItemOwnerProperty);
{
  RegisterPropertyEditor(TypeInfo(TImageIndex), TDictionaryItem, 'NodeImageIndex',
                         TIntegerProperty);
  RegisterPropertyEditor(TypeInfo(TImageIndex), TDictionaryItem, 'NodeSelectedIndex',
                         TIntegerProperty);
  RegisterPropertyEditor(TypeInfo(TImageIndex), TDictionaryItem, 'NodeStateIndex',
                         TIntegerProperty);
}
end;

end.
