//==============================================
//      File rdbedit.pas
//
//      Components library for Delphi, BCB++, Kylix.
//      Descendant of TDBEdit.
//
//      Copyright 1998-2001 Polaris Software
//      http://polesoft.da.ru
//      mailto: PolarisLib@mail.ru
//==============================================
unit rDBEdit;

{$I POLARIS.INC}

interface

uses
  SysUtils, Classes,
{$IFDEF LINUX}
  QControls, QComCtrls, QMenus, QMask, QDBCtrls, DB, Variants;
{$ELSE}
  Windows, Messages, Graphics, Controls, Forms, Dialogs,
  ToolWin, ComCtrls, Menus, StdCtrls, Mask, DBCtrls, DB,
  {$IFDEF POLARIS_D6}RxStrUtils, Variants{$ELSE}StrUtils{$ENDIF};
{$ENDIF}

type
  TUpperCase = (ucNone, ucOnlyFirst{$IFNDEF LINUX}, ucInitials{$ENDIF});

  TrDBEdit = class(TDBEdit)
  private
    { Private declarations }
    FUpperCase: TUpperCase;
    FTrimBlanks: Boolean;
{$IFNDEF LINUX}
    procedure CMExit(var Message: TCMExit); message CM_EXIT;
{$ENDIF}
  protected
{$IFDEF LINUX}
    procedure DoExit; override;
{$ENDIF}
  public
    { Public declarations }
    constructor Create(AOwner: TComponent); override;
  published
    { Published declarations }
    property UpperCase: TUpperCase read FUpperCase write FUpperCase default ucOnlyFirst;
    property TrimBlanks: Boolean read FTrimBlanks write FTrimBlanks default True;
  end;

implementation

constructor TrDBEdit.Create(AOwner: TComponent);
begin
  inherited Create(AOwner);
  FUpperCase := ucOnlyFirst;
  FTrimBlanks := True;
end;

{$IFDEF LINUX}
procedure TrDBEdit.DoExit;
{$ELSE}
procedure TrDBEdit.CMExit(var Message: TCMExit);
{$ENDIF}
begin
  if not Modified then exit;
  if FTrimBlanks then Text := Trim(Text);
  if (Length(Text) <> 0) and (DataSource.State in dsEditModes) then begin
    if FUpperCase = ucOnlyFirst then
      Text := AnsiUpperCase(String(Text[1]))+Copy(Text,2,Length(Text))
{$IFNDEF LINUX}
    else
      if FUpperCase = ucInitials then
        Text := AnsiProperCase(Text,[' ','.',',','-']);
{$ENDIF}
  end;
  inherited;
  if Length(Text)=0 then
    with DataSource do
      if State in dsEditModes then DataSet[DataField] := NULL;
end;

end.
