//==============================================
//      File rplugset.pas
//
//      Components library for Delphi and BCB++.
//         .
//      Plugins setup form.
//
//      Copyright 1998-2002 Polaris Software
//      http://polesoft.da.ru
//      mailto: PolarisLib@mail.ru
//==============================================
unit rPlugSet;

interface

uses
  Windows, Classes, Controls, Forms, Buttons, ComCtrls, StdCtrls, ExtCtrls,
  rPlugins, rConst;

type
  TfmPlugsSet = class(TForm)
    box: TScrollBox;
    stat: TStatusBar;
    pnClient: TPanel;
    pnButtons: TPanel;
    btOk: TBitBtn;
    btCancel: TBitBtn;
    procedure boxResize(Sender: TObject);
  private
    { Private declarations }
  public
    { Public declarations }
  end;

function SetupPlugins(Plugins: TrPlugins): Boolean;

implementation

{$R *.DFM}

procedure TfmPlugsSet.boxResize(Sender: TObject);
var
  i : Integer;
begin
  for i := 0 to box.ComponentCount - 1 do
    if (box.Components[i] is TComboBox) then
       (box.Components[i] as TControl).Width := box.Width - 20;
  btOk.Left := Width - 2 * btOk.Width - 30;
  btCancel.Left := Width - btCancel.Width - 20;
end;

function SetupPlugins(Plugins: TrPlugins): Boolean;
var
  i,j: Integer;
  lb: TLabel;
  cb: TComboBox;
  slTypes: TStringList;
begin
  Result := False;
  slTypes := TStringList.Create;
  with TfmPlugsSet.Create(nil) do try

    slTypes.Text := Plugins.GetPlugTypes;
    for i := 0 to slTypes.Count - 1 do begin
      lb := TLabel.Create(box);
      lb.Parent := box;
      lb.Caption := slTypes.Strings[i]+':';
      lb.Left := 10;
      lb.Top := 10+40*(i);
      lb.Tag := 0;
      cb := TComboBox.Create(box);
      cb.Parent := box;
      cb.Items.Text := Plugins.GetPlugNames(slTypes.Strings[i]);
      cb.Left := 10;
      cb.Top := 25+40*(i);
      cb.Width := box.Width-20;
      cb.Style := csDropDownList;
      cb.Tag := i + 1;
      for j := 0 to cb.Items.Count - 1 do
        if Plugins.GetDefaultPlug(slTypes.Strings[i]) = cb.Items.Strings[j]
          then cb.ItemIndex := j;
    end;

    Caption := srPlugSetCaption;
    ShowModal;

    if ModalResult = mrOk then begin
      with box do for i := 0 to ComponentCount - 1 do
        if Components[i].Tag <> 0 then Plugins.SetDefaultPlug(
          slTypes.Strings[Components[i].Tag - 1], TComboBox(Components[i]).Text);
      Plugins.SaveParamsToReg;
    end;

  finally
    Free;
    slTypes.Free;
  end;
end;

end.

